# Don't enable debuginfo package, what's left to strip shouldn't be!
%define debug_package %{nil}

# Define to use the basiclite source and create a basiclite package instead of
# the full-featured basic.
#define lite lite

%define ora_rel_i386 .0
%define ora_arch_i386 linux
%define ora_rel_x86_64 .0
%define ora_arch_x86_64 linux-x64

%define ora_dir instantclient_10_2

Summary: Instant Client for Oracle Database 10g
Name: oracle-instantclient
Version: 10.2.0.5
Release: 2.vvm%{?dist}
Group: Applications/Databases
License: Oracle Proprietary, see included instantclient-license.txt
Source10: http://jeanchristophe.duber.free.fr/dbd_oracle_instantclient_linux/oracle-instantclient-config

URL: http://www.oracle.com/technology/tech/oci/instantclient/instantclient.html
Source1:   instantclient-license.txt
Source100: basic%{?lite}-%{version}%{?ora_rel_i386}-%{ora_arch_i386}.zip
Source101: jdbc-%{version}%{?ora_rel_i386}-%{ora_arch_i386}.zip
Source102: odbc-%{version}%{?ora_rel_i386}-%{ora_arch_i386}.zip
Source103: sdk-%{version}%{?ora_rel_i386}-%{ora_arch_i386}.zip
Source104: sqlplus-%{version}%{?ora_rel_i386}-%{ora_arch_i386}.zip
# updated OCCI libs
#Source110: http://www.oracle.com/technology/tech/oci/occi/downloads/occi_gcc343_102030.tar.gz
Source111: libocci10_343.so.10.1
Source112: libocci10_343.a

Source200: basic%{?lite}-%{version}%{?ora_rel_x86_64}-%{ora_arch_x86_64}.zip
Source201: jdbc-%{version}%{?ora_rel_x86_64}-%{ora_arch_x86_64}.zip
Source202: odbc-%{version}%{?ora_rel_x86_64}-%{ora_arch_x86_64}.zip
Source203: sdk-%{version}%{?ora_rel_x86_64}-%{ora_arch_x86_64}.zip
Source204: sqlplus-%{version}%{?ora_rel_x86_64}-%{ora_arch_x86_64}.zip
# updated OCCI libs
#Source210: http://www.oracle.com/technology/tech/oci/occi/downloads/occi_gcc343_x86_64_102030.tar.gz
Source211: libocci10_343.so.10.1.64bit
Source212: libocci10_343.a.64bit

Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root
%if %(grep -q '4.' /etc/redhat-release && echo 0 || echo 1 )
# brp-java-repack-jars creates invalid temp files with previous versions:
BuildRequires: redhat-rpm-config >= 8.0.45-24.el5
%endif
ExclusiveArch: i386 x86_64

%ifarch i386
Source0: %{SOURCE100}
%endif
%ifarch x86_64
Source0: %{SOURCE200}
%endif

%description
Instant Client for Oracle Database 10g.


%package basic%{?lite}
Summary: Instant Client for Oracle Database 10g
Group: Applications/Databases
%{?lite:Provides: %{name}-basic = %{version}-%{release}}
Requires: /sbin/ldconfig

%description basic%{?lite}
Base files for Instant Client which include support for OCI, OCCI, and JDBC-OCI
applications.


%package devel
Summary: Development headers for Instant Client
Group: Applications/Databases
Requires: %{name}-basic = %{version}

%description devel
Additional header files and an example Makefile for developing Oracle
applications with Instant Client.


%package jdbc
Summary: Supplemental JDBC features under Instant Client
Group: Applications/Databases
Requires: %{name}-basic = %{version}

%description jdbc
Additional support for XA, Internationalization, and RowSet operations under
JDBC in Instant Client.

%package odbc
Summary: ODBC for Instant Client
Group: Applications/Databases
Requires: %{name}-basic = %{version}

%description odbc
Additional libraries for enabling ODBC support in Instant Client.


%package sqlplus
Summary: SQL*Plus for Instant Client
Group: Applications/Databases
Requires: %{name}-basic = %{version}

%description sqlplus
Additional libraries and executable for running SQL*Plus with Instant Client.


%prep
%ifarch i386
%setup -c %{name}-%{version} -a 101 -a 102 -a 103 -a 104 
%endif
%ifarch x86_64
%setup -c %{name}-%{version} -a 201 -a 202 -a 203 -a 204 
%endif

%install
%{__rm} -rf %{buildroot}

# copy over license into build area
cp %{SOURCE1} %{ora_dir}/

# All the original Oracle files

%{__mkdir_p} %{buildroot}%{_bindir}
%{__mkdir_p} %{buildroot}%{_libdir}/oracle/%{version}/client/bin
%{__mkdir_p} %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}
%{__mkdir_p} %{buildroot}%{_includedir}/oracle/%{version}/client/
%{__mkdir_p} %{buildroot}%{_datadir}/oracle/%{version}/client/

# basic/jdbc/odbc/sqlplus
%{__cp} -a %{ora_dir}/{*.so*,*.jar,*.sql} \
    %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}/
%{__cp} -a %{ora_dir}/sqlplus \
    %{buildroot}%{_libdir}/oracle/%{version}/client/bin/

%{__ln_s} %{_libdir}/oracle/%{version}/client/bin/sqlplus \
    %{buildroot}%{_bindir}/sqlplus

# OCCI mess fixup for gcc-3.4.3
# do we really need this symlink mess, or will everybody just look for the libocci10.* anyway?
echo "replacing libocci"
%ifarch i386
pushd %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}
%{__rm} -fv libocci10.so.10.1 libocci.so.10.1 libocci10.a libocci.a
%{__install} -m755 %SOURCE111 libocci10_343.so.10.1

# yet another hack. this time to give a "proper" SONAME to the
# ORACLE-provided gcc343-compiled libraries..  
echo "binary patching correct SONAME for libocci.."
c=`grep --count libocci10_343.so.10.1 libocci10_343.so.10.1`
if [ "$c" ne "1" ]; then      # safe, not sorry
   echo "ERROR: multiple orrcuences of SONAME in libocci10_343.so.10.1 ??"
   exit 1
fi
sed -e 's/libocci10_343.so.10.1/libocci.so.10.1\x00SLC5\x00/' <libocci10_343.so.10.1 > libocci.so.10.1
%{__install} -m644 %SOURCE112 libocci10.a
%{__ln_s} libocci10.a libocci.a
popd
%endif
%ifarch x86_64
echo "replacing libocci (64bit)"
pushd %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}
%{__rm} -fv libocci10.so.10.1 libocci.so.10.1 libocci10.a libocci.a
%{__install} -m755 %SOURCE211 libocci10_343.so.10.1
# yet another hack. this time to give a "proper" SONAME to the
# ORACLE-provided gcc343-compiled libraries..  
echo "binary patching correct SONAME for libocci.."
c=`grep --count libocci10_343.so.10.1 libocci10_343.so.10.1`
if [ "$c" ne "1" ]; then      # safe, not sorry
   echo "ERROR: multiple orrcuences of SONAME in libocci10_343.so.10.1 ??"
   exit 1
fi
sed -e 's/libocci10_343.so.10.1/libocci.so.10.1\x00SLC5\x00/' <libocci10_343.so.10.1 > libocci.so.10.1
%{__install} -m644 %SOURCE212 libocci10.a
%{__ln_s} libocci10.a libocci.a
popd
%endif

# devel (sdk)
%{__cp} -a %{ora_dir}/sdk/include/*.h \
    %{buildroot}%{_includedir}/oracle/%{version}/client/
%{__cp} -a %{ora_dir}/sdk/demo/* \
    %{buildroot}%{_datadir}/oracle/%{version}/client/
for file in libclntsh.so libocci.so; do
    pushd %{buildroot}%{_libdir}/oracle/%{version}/client/%{_lib}
    %{__ln_s} ${file}.* ${file}
    popd
done

# All the custom files

# Install the ld.so.conf.d entry for the libs to be found
%{__mkdir_p} %{buildroot}%{_sysconfdir}/ld.so.conf.d
cat > %{buildroot}%{_sysconfdir}/ld.so.conf.d/oracle-instantclient.conf << EOF
%{_libdir}/oracle/%{version}/client/%{_lib}
EOF


# Install the profile.d entry for the env. variable to be set
%{__mkdir_p} %{buildroot}%{_sysconfdir}/profile.d
cat > %{buildroot}%{_sysconfdir}/profile.d/oracle.sh << EOF
#export ORACLE_HOME="%{_libdir}/oracle/%{version}/client"
#export TNS_ADMIN=%{_sysconfdir}
export NLS_LANG=AMERICAN_AMERICA.WE8ISO8859P1
EOF

# Install the config script, replace /opt with /usr, lib and version
%{__install} -D %{SOURCE10} %{buildroot}%{_bindir}/oracle-instantclient-config
%{__perl} -pi -e 's|^prefix=.*|prefix=/usr|g;
                  s|/lib|/%{_lib}|g;
                  s|^version=.*|version=%{version}|g' \
    %{buildroot}%{_bindir}/oracle-instantclient-config


%clean
%{__rm} -rf %{buildroot}


%post basic%{?lite}
if /bin/grep -q 3.0 /etc/redhat-release > /dev/null ; then
 if [ "${1}" -eq 1 ]; then
  /bin/grep -v -e '%{_libdir}/oracle/%{version}/client/%{_lib}' %{_sysconfdir}/ld.so.conf > %{_sysconfdir}/ld.so.conf~
  /bin/echo '%{_libdir}/oracle/%{version}/client/%{_lib}' > %{_sysconfdir}/ld.so.conf
  /bin/cat %{_sysconfdir}/ld.so.conf~ >> %{_sysconfdir}/ld.so.conf
  /bin/rm %{_sysconfdir}/ld.so.conf~
 fi
else
  # v4,v5 have SELinux, and the 10.2.0.4 libraries trigger a warning on prelink
 textreloclib="libnnz10.so libociei.so libocijdbc10.so libsqlplus.so libsqlplusic.so libclntsh.so.10.1 libocci10_343.so.10.1 libocci.so.10.1 libsqora.so.10.1 libheteroxa10.so"
 if [ -x /usr/bin/chcon ]; then
  echo "fixing SELinux textrelocation issue with ORACLE libraires"
  for i in $textreloclib; do
     if [ -f "%{_libdir}/oracle/%{version}/client/%{_lib}/${i}" ]; then
        /usr/bin/chcon --silent -t textrel_shlib_t "%{_libdir}/oracle/%{version}/client/%{_lib}/${i}" || true
     fi
  done
 fi
 # semanage is a v5-only thing, and is smart enough to not add existing rules
 if [ -x /usr/sbin/semanage ]; then
  for i in $textreloclib; do
    if [ -f "%{_libdir}/oracle/%{version}/client/%{_lib}/${i}" ]; then
      /usr/sbin/semanage fcontext -a -t textrel_shlib_t "%{_libdir}/oracle/%{version}/client/%{_lib}/${i}" || true
    fi
  done
 fi
fi
/sbin/ldconfig || true

%postun basic%{?lite}
/sbin/ldconfig || true

%post jdbc
/sbin/ldconfig || true

%postun jdbc
/sbin/ldconfig || true

%post odbc
/sbin/ldconfig || true

%postun odbc
/sbin/ldconfig || true

%post sqlplus
/sbin/ldconfig || true

%postun sqlplus
/sbin/ldconfig || true


%files basic%{?lite}
%defattr(-, root, root, 0755)
# Custom files
%attr(0644, root, root) %config %{_sysconfdir}/ld.so.conf.d/oracle-instantclient.conf
%attr(0755, root, root) %config(noreplace) %{_sysconfdir}/profile.d/oracle.sh
%attr(0755, root, root) %{_bindir}/oracle-instantclient-config
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_libdir}/oracle/%{version}/client/%{_lib}/classes12.jar
%{_libdir}/oracle/%{version}/client/%{_lib}/libclntsh.so.*
%{_libdir}/oracle/%{version}/client/%{_lib}/libnnz10.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci*.so.*
%{!?lite:%{_libdir}/oracle/%{version}/client/%{_lib}/libociei.so}
%{?lite:%{_libdir}/oracle/%{version}/client/%{_lib}/libociicus.so}
%{_libdir}/oracle/%{version}/client/%{_lib}/libocijdbc10.so
%{_libdir}/oracle/%{version}/client/%{_lib}/ojdbc14.jar

# License
%doc %{ora_dir}/instantclient-license.txt

%files devel
%defattr(-, root, root, 0755)
# Custom files
%dir %{_includedir}/oracle/
%dir %{_includedir}/oracle/%{version}/
%dir %{_includedir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
%dir %{_datadir}/oracle/
%dir %{_datadir}/oracle/%{version}/
%dir %{_datadir}/oracle/%{version}/client/
# Original Oracle files
%{_includedir}/oracle/%{version}/client/*.h
%{_libdir}/oracle/%{version}/client/%{_lib}/libclntsh.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci.a
%{_libdir}/oracle/%{version}/client/%{_lib}/libocci10.a
%{_datadir}/oracle/%{version}/client/*

%files jdbc
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_libdir}/oracle/%{version}/client/%{_lib}/libheteroxa10.so
%{_libdir}/oracle/%{version}/client/%{_lib}/orai18n.jar

%files odbc
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
#%dir %{_libdir}/oracle/%{version}/client/bin/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%doc %{ora_dir}/ODBC*.htm*
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqora.so.*

%files sqlplus
%defattr(-, root, root, 0755)
# Custom files
%dir %{_libdir}/oracle/
%dir %{_libdir}/oracle/%{version}/
%dir %{_libdir}/oracle/%{version}/client/
%dir %{_libdir}/oracle/%{version}/client/bin/
%dir %{_libdir}/oracle/%{version}/client/%{_lib}/
# Original Oracle files
%{_bindir}/sqlplus
%{_libdir}/oracle/%{version}/client/bin/sqlplus
%{_libdir}/oracle/%{version}/client/%{_lib}/glogin.sql
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqlplus.so
%{_libdir}/oracle/%{version}/client/%{_lib}/libsqlplusic.so


%changelog
* Thu Nov 03 2011 vvm@jinr.ru
- Build for SL5

